"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DnDSortable = void 0;
const SXDiv_1 = __importDefault(require("@thatweb/core-mui/components/sx/SXDiv"));
const useSXStyle_1 = __importDefault(require("@thatweb/core-mui/hooks/useSXStyle"));
const react_1 = __importStar(require("react"));
const DnDSortableController_1 = __importStar(require("../controllers/DnDSortableController"));
exports.default = DnDSortable;
function DnDSortable(props) {
    const { children = null } = props;
    return (react_1.default.createElement(DnDSortableController_1.default, Object.assign({}, props),
        react_1.default.createElement(DnDSortableInner, null),
        children));
}
exports.DnDSortable = DnDSortable;
function DnDSortableInner() {
    const { doRenderItem, doMouseEnter, doMouseLeave } = (0, DnDSortableController_1.useDnDSortableActions)();
    const depth = (0, DnDSortableController_1.useDnDSortableDepth)();
    const items = (0, DnDSortableController_1.useDnDSortableItems)();
    const active = (0, DnDSortableController_1.useDnDSortableActive)();
    const indentForAboveSortables = (depth + 4) * 40;
    const sxStyle = (0, useSXStyle_1.default)(() => ({
        sx: {
            '&>.DnDSortable': {
                '&.DnDActive': {
                    '& .DnDSortable': {
                        pointerEvents: 'none',
                    },
                    '& .DnDAboveDropZone .DnDSortableOuter': {
                        position: 'relative',
                        '&>.DnDSortableStretchyBit': {
                            pointerEvents: 'initial',
                            position: 'absolute',
                            left: `${indentForAboveSortables}px`,
                            right: 0,
                            minHeight: 90,
                            top: '-45px',
                        },
                        '&>.DnDSortable': {
                            pointerEvents: 'initial',
                            position: 'relative',
                        },
                    },
                    '& .DnDBelowDropZone .DnDSortableOuter': {
                        '&>.DnDSortable': {
                            pointerEvents: 'initial',
                        },
                    },
                },
            },
        },
    }), [indentForAboveSortables]);
    return (0, react_1.useMemo)(() => (react_1.default.createElement(SXDiv_1.default, Object.assign({ className: "DnDSortableOuter" }, sxStyle),
        react_1.default.createElement(SXDiv_1.default, { className: 'DnDSortableStretchyBit', onMouseEnter: doMouseEnter, onMouseLeave: doMouseLeave }),
        react_1.default.createElement(SXDiv_1.default, { className: ['DnDSortable', active ? 'DnDActive' : ''].join(' '), onMouseEnter: doMouseEnter, onMouseLeave: doMouseLeave }, items.map(doRenderItem)))), [active, doMouseEnter, doMouseLeave, doRenderItem, items, sxStyle]);
}
//# sourceMappingURL=DnDSortable.js.map