"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDSortableActive = exports.useDnDSortableRowHeight = exports.useDnDSortableDepth = exports.useDnDSortableDisabled = exports.useDnDSortableItems = exports.useDnDSortableActions = exports.DnDSortableActionsContext = exports.DnDSortableContext = exports.DnDSortableController = void 0;
const useCtrlActionsCtx_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlActionsCtx"));
const useCtrlCtx_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlCtx"));
const useCtrlState_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlState"));
const react_1 = __importStar(require("react"));
const useDnDSortableDoDrop_1 = __importDefault(require("./actions/useDnDSortableDoDrop"));
const useDnDSortableDoLoseControl_1 = __importDefault(require("./actions/useDnDSortableDoLoseControl"));
const useDnDSortableDoMouseEnter_1 = __importDefault(require("./actions/useDnDSortableDoMouseEnter"));
const useDnDSortableDoMouseLeave_1 = __importDefault(require("./actions/useDnDSortableDoMouseLeave"));
const useDnDSortableDoMouseMove_1 = __importDefault(require("./actions/useDnDSortableDoMouseMove"));
const useDnDSortableDoRenderItem_1 = __importDefault(require("./actions/useDnDSortableDoRenderItem"));
const useDnDSortableDoTakeControlFrom_1 = __importDefault(require("./actions/useDnDSortableDoTakeControlFrom"));
const useDnDSortableEffects_1 = __importDefault(require("./actions/useDnDSortableEffects"));
const useDnDSortablePlaceDropZone_1 = __importDefault(require("./actions/useDnDSortablePlaceDropZone"));
exports.default = DnDSortableController;
function DnDSortableController(props) {
    const { children } = props, otherProps = __rest(props, ["children"]);
    const _s = (0, useCtrlState_1.default)(Object.assign({}, otherProps));
    const _a = (0, react_1.useRef)({});
    _a.current._placeDropZone = (0, useDnDSortablePlaceDropZone_1.default)(_s, _a);
    _a.current.doMouseEnter = (0, useDnDSortableDoMouseEnter_1.default)(_s, _a);
    _a.current.doMouseLeave = (0, useDnDSortableDoMouseLeave_1.default)(_s, _a);
    _a.current.doDrop = (0, useDnDSortableDoDrop_1.default)(_s, _a);
    _a.current.doMouseMove = (0, useDnDSortableDoMouseMove_1.default)(_s, _a);
    _a.current.doRenderItem = (0, useDnDSortableDoRenderItem_1.default)(_s, _a);
    _a.current.doLoseControl = (0, useDnDSortableDoLoseControl_1.default)(_s, _a);
    _a.current.doTakeControlFrom = (0, useDnDSortableDoTakeControlFrom_1.default)(_s, _a);
    (0, useDnDSortableEffects_1.default)(_s, _a, props);
    const ctx = (0, useCtrlCtx_1.default)(_s);
    const actionsCtx = (0, useCtrlActionsCtx_1.default)(_a, 'DnDSortable');
    return (react_1.default.createElement(exports.DnDSortableContext.Provider, { value: ctx },
        react_1.default.createElement(exports.DnDSortableActionsContext.Provider, { value: actionsCtx }, children)));
}
exports.DnDSortableController = DnDSortableController;
exports.DnDSortableContext = react_1.default.createContext(null);
exports.DnDSortableActionsContext = react_1.default.createContext(null);
const useDnDSortableActions = () => (0, react_1.useContext)(exports.DnDSortableActionsContext);
exports.useDnDSortableActions = useDnDSortableActions;
function useDnDSortableItems() {
    const { items } = (0, react_1.useContext)(exports.DnDSortableContext);
    return (0, react_1.useMemo)(() => items !== null && items !== void 0 ? items : [], [items]);
}
exports.useDnDSortableItems = useDnDSortableItems;
function useDnDSortableDisabled() {
    const { disabled } = (0, react_1.useContext)(exports.DnDSortableContext);
    return (0, react_1.useMemo)(() => disabled !== null && disabled !== void 0 ? disabled : false, [disabled]);
}
exports.useDnDSortableDisabled = useDnDSortableDisabled;
function useDnDSortableDepth() {
    const { depth } = (0, react_1.useContext)(exports.DnDSortableContext);
    return (0, react_1.useMemo)(() => depth !== null && depth !== void 0 ? depth : 0, [depth]);
}
exports.useDnDSortableDepth = useDnDSortableDepth;
function useDnDSortableRowHeight() {
    const { rowHeight } = (0, react_1.useContext)(exports.DnDSortableContext);
    return (0, react_1.useMemo)(() => rowHeight !== null && rowHeight !== void 0 ? rowHeight : 0, [rowHeight]);
}
exports.useDnDSortableRowHeight = useDnDSortableRowHeight;
function useDnDSortableActive() {
    const { active } = (0, react_1.useContext)(exports.DnDSortableContext);
    return (0, react_1.useMemo)(() => active !== null && active !== void 0 ? active : false, [active]);
}
exports.useDnDSortableActive = useDnDSortableActive;
//# sourceMappingURL=DnDSortableController.js.map