"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDSortableDoDrop = void 0;
const react_1 = require("react");
exports.default = useDnDSortableDoDrop;
function useDnDSortableDoDrop({ current: _s }, { current: _a }) {
    return (0, react_1.useCallback)(({ data: item }) => {
        var _b, _c;
        if (_s.dropZoneIdx === undefined)
            return;
        let adjustedIdx = _s.dropZoneIdx;
        const currentIdx = (_c = (_b = _s.items) === null || _b === void 0 ? void 0 : _b.findIndex(i => i.id === item.id)) !== null && _c !== void 0 ? _c : -1;
        if (currentIdx >= 0 && currentIdx <= _s.dropZoneIdx)
            adjustedIdx -= 1;
        _a._placeDropZone(undefined);
        _s.setChanged();
        _s.onDrop(item, adjustedIdx);
    }, [_s, _a]);
}
exports.useDnDSortableDoDrop = useDnDSortableDoDrop;
//# sourceMappingURL=useDnDSortableDoDrop.js.map