"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDDoSetPosition = void 0;
const react_1 = require("react");
exports.default = useDnDDoSetPosition;
function useDnDDoSetPosition({ current: _s }, { current: _a }) {
    return (0, react_1.useCallback)((id, position, andRaw = false) => {
        if (andRaw || !_s.dragItemPositionRaw)
            _s.dragItemPositionRaw = Object.assign({}, position);
        _s.dragItemPosition = Object.assign({}, position);
        _s.setChanged();
    }, [_s]);
}
exports.useDnDDoSetPosition = useDnDDoSetPosition;
//# sourceMappingURL=useDnDDoSetPosition.js.map