"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDSortableDoLoseControl = void 0;
const react_1 = require("react");
const DnDController_1 = require("../DnDController");
const DnDSortableController_1 = require("../DnDSortableController");
exports.default = useDnDSortableDoLoseControl;
function useDnDSortableDoLoseControl({ current: _s }, { current: _a }) {
    const parentActions = (0, DnDSortableController_1.useDnDSortableActions)();
    const { doSetDropZone } = (0, DnDController_1.useDnDActions)();
    return (0, react_1.useCallback)(() => {
        if (_s.enterTimeout)
            clearTimeout(_s.enterTimeout);
        _s.enterTimeout = undefined;
        _s.active = false;
        _a._placeDropZone(undefined);
        doSetDropZone(undefined);
        parentActions === null || parentActions === void 0 ? void 0 : parentActions.doLoseControl();
    }, [_s, _a, parentActions, doSetDropZone]);
}
exports.useDnDSortableDoLoseControl = useDnDSortableDoLoseControl;
//# sourceMappingURL=useDnDSortableDoLoseControl.js.map