"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDSortableDoMouseLeave = void 0;
const react_1 = require("react");
const DnDController_1 = require("../DnDController");
const DnDSortableController_1 = require("../DnDSortableController");
exports.default = useDnDSortableDoMouseLeave;
function useDnDSortableDoMouseLeave({ current: _s }, { current: _a }) {
    const parentActions = (0, DnDSortableController_1.useDnDSortableActions)();
    const { doSetDropZone } = (0, DnDController_1.useDnDActions)();
    return (0, react_1.useCallback)((e) => {
        var _b;
        if (_s.enterTimeout)
            clearTimeout(_s.enterTimeout);
        _s.enterTimeout = undefined;
        _s.active = false;
        _a._placeDropZone(undefined);
        doSetDropZone(undefined);
        (_b = parentActions === null || parentActions === void 0 ? void 0 : parentActions.doTakeControlFrom) === null || _b === void 0 ? void 0 : _b.call(parentActions, _s.listId);
    }, [_s, _a, parentActions, doSetDropZone]);
}
exports.useDnDSortableDoMouseLeave = useDnDSortableDoMouseLeave;
//# sourceMappingURL=useDnDSortableDoMouseLeave.js.map