"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDSortableDoTakeControlFrom = void 0;
const useAsRef_1 = __importDefault(require("@thatreact/core-hooks/hooks/useAsRef"));
const react_1 = require("react");
const DnDController_1 = require("../DnDController");
exports.default = useDnDSortableDoTakeControlFrom;
function useDnDSortableDoTakeControlFrom({ current: _s }, { current: _a }) {
    const isDragging = (0, useAsRef_1.default)((0, DnDController_1.useDnDIsDragging)());
    const { doSetDropZone } = (0, DnDController_1.useDnDActions)();
    return (0, react_1.useCallback)((id) => {
        var _b, _c;
        doSetDropZone({ id: _s.listId, onDrop: _a.doDrop });
        if (!isDragging.current)
            return;
        _s.active = true;
        const itemIdx = (_c = (_b = _s.items) === null || _b === void 0 ? void 0 : _b.findIndex(i => i.id === id)) !== null && _c !== void 0 ? _c : -1;
        _a._placeDropZone(itemIdx + 1);
    }, [_s, _a, isDragging, doSetDropZone]);
}
exports.useDnDSortableDoTakeControlFrom = useDnDSortableDoTakeControlFrom;
//# sourceMappingURL=useDnDSortableDoTakeControlFrom.js.map